/**
 * @license
 * @version 0.2.5
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
define("router5",[],function(){var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var n=function n(t){return"("+(t?t.replace(/(^<|>$)/g,""):"[a-zA-Z0-9-_.~]+")+")"};var r=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(n(t[2]))}},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(";"+t[1]+"="+n(t[2]))}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function a(t){return new RegExp(t[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function a(t){return new RegExp(t[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function a(t){return new RegExp(t[0])}}];var i=function i(t){var e=arguments[1]===undefined?[]:arguments[1];var n=r.some(function(n){var r=t.match(n.pattern);if(!r)return false;e.push({type:n.name,match:r[0],val:r.slice(1,2),otherVal:r.slice(2),regex:n.regex instanceof Function?n.regex(r):n.regex});if(r[0].length<t.length)e=i(t.substr(r[0].length),e);return true});if(!n){throw new Error("Could not parse path.")}return e};var s=function(){function r(t){e(this,r);if(!t)throw new Error("Please supply a path");this.path=t;this.tokens=i(t);this.hasUrlParams=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(t){return/splat$/.test(t.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(t){return/matrix$/.test(t.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(t){return t.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).map(function(t){return t.val.slice(0,1)}).reduce(function(t,e){return t.concat(e)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(t){return t.type==="query-parameter"}).map(function(t){return t.val}).reduce(function(t,e){return t.concat(e)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(t){return t.regex!==undefined}).map(function(t){return t.regex.source}).join("")}t(r,[{key:"_urlMatch",value:function a(t,e){var n=this;var r=t.match(e);if(!r)return null;else if(!this.urlParams.length)return{};return r.slice(1,this.urlParams.length+1).reduce(function(t,e,r){t[n.urlParams[r]]=e;return t},{})}},{key:"match",value:function s(t){var e=this;var n=this._urlMatch(t,new RegExp("^"+this.source+(this.hasQueryParams?"?.*$":"$")));if(!n||!this.hasQueryParams)return n;var r=t.split("?")[1].split("&").map(function(t){return t.split("=")}).reduce(function(t,e){t[e[0]]=e[1];return t},{});if(Object.keys(r).every(function(t){return Object.keys(e.queryParams).indexOf(t)!==1})&&Object.keys(r).length===this.queryParams.length){Object.keys(r).forEach(function(t){return n[t]=r[t]});return n}return null}},{key:"partialMatch",value:function u(t){return this._urlMatch(t,new RegExp("^"+this.source))}},{key:"build",value:function o(){var t=arguments[0]===undefined?{}:arguments[0];var e=arguments[1]===undefined?false:arguments[1];if(!this.params.every(function(e){return t[e]!==undefined}))throw new Error("Missing parameters");if(!e){var r=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)&&!/-splat$/.test(t.type)}).every(function(e){return new RegExp("^"+n(e.otherVal[0])+"$").test(t[e.val])});if(!r)throw new Error("Some parameters are of invalid format")}var a=this.tokens.filter(function(t){return t.type!=="query-parameter"}).map(function(e){if(e.type==="url-parameter-matrix")return";"+e.val[0]+"="+t[e.val[0]];return/^url-parameter/.test(e.type)?t[e.val[0]]:e.match}).join("");var i=this.queryParams.map(function(e){return e+"="+t[e]}).join("&");return a+(i?"?"+i:"")}}]);return r}();var u={ROUTER_NOT_STARTED:1,ROUTER_ALREADY_STARTED:2,SAME_STATES:10,CANNOT_DEACTIVATE:11,CANNOT_ACTIVATE:12,NODE_LISTENER_ERR:13,TRANSITION_CANCELLED:20};var o=function(){function n(){var t=arguments[0]===undefined?"":arguments[0];var r=arguments[1]===undefined?"":arguments[1];var a=arguments[2]===undefined?[]:arguments[2];e(this,n);this.name=t;this.path=r;this.parser=r?new s(r):null;this.children=[];this.add(a);return this}t(n,[{key:"add",value:function r(t){var e=this;if(t instanceof Array){t.forEach(function(t){return e.add(t)});return}if(!(t instanceof n)&&!(t instanceof Object)){throw new Error("Route constructor expects routes to be an Object or an instance of Route.")}if(t instanceof Object){if(!t.name||!t.path){throw new Error("Route constructor expects routes to have an name and a path defined.")}t=new n(t.name,t.path,t.children)}if(this.children.map(function(t){return t.name}).indexOf(t.name)!==-1){throw new Error('Alias "'+t.name+'" is already defined in route node')}if(this.children.map(function(t){return t.path}).indexOf(t.path)!==-1){throw new Error('Path "'+t.path+'" is already defined in route node')}var r=t.name.split(".");if(r.length===1){this.children.push(t);this.children.sort(function(t,e){if(!t.parser.hasSpatParam&&e.parser.hasSpatParam)return-1;if(!e.parser.hasSpatParam&&t.parser.hasSpatParam)return 1;if(!t.parser.hasUrlParams&&e.parser.hasUrlParams)return-1;if(!e.parser.hasUrlParams&&t.parser.hasUrlParams)return 1;return t.path&&e.path?t.path.length<e.path.length:0})}else{var a=this.getSegmentsByName(r.slice(0,-1).join("."));if(a){a[a.length-1].add(new n(r[r.length-1],t.path,t.children))}else{throw new Error("Could not add route named '"+t.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(t,e){this.add(new n(t,e));return this}},{key:"getSegmentsByName",value:function i(t){var e=function e(t,e){var n=e.filter(function(e){return e.name===t});return n.length?n[0]:undefined};var n=[];var r=t.split(".");var a=this.children;var i=r.every(function(t){var r=e(t,a);if(r){a=r.children;n.push(r);return true}return false});return i?n:null}},{key:"getSegmentsMatchingPath",value:function u(t){var e=function e(t,n,r){var a=function(a){var i=t[a];var s=i.parser.partialMatch(n);if(s){r.push(i);Object.keys(s).forEach(function(t){return r.params[t]=s[t]});var u=n.replace(i.parser.build(s),"");if(!u.length){return{v:r}}if(!i.children.length){return{v:null}}return{v:e(i.children,u,r)}}};for(var i in t){var s=a(i);if(typeof s==="object")return s.v}return null};var n=this.parser?[this]:this.children;var r=[];r.params={};return e(n,t,r)}},{key:"getPathFromSegments",value:function o(t){return t?t.map(function(t){return t.path}).join(""):null}},{key:"getPath",value:function h(t){return this.getPathFromSegments(this.getSegmentsByName(t))}},{key:"buildPathFromSegments",value:function l(t){var e=arguments[1]===undefined?{}:arguments[1];return t?t.map(function(t){return t.parser.build(e)}).join(""):null}},{key:"buildPath",value:function f(t){var e=arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(t),e)}},{key:"getMatchPathFromSegments",value:function c(t){if(!t)return null;var e=t.map(function(t){return t.name}).join(".");var n=t.params;return{name:e,params:n}}},{key:"matchPath",value:function m(t){return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(t))}}]);return n}();function h(t,e,n,r){var a=arguments[4]===undefined?false:arguments[4];var i=t||[];var s=function s(t){if(!i.length)return true;var r=i[0].length;var s=i[0](e,n,t);if(typeof s==="boolean")t(s?null:true);else if(s&&typeof s.then==="function"){s.then(function(){return t(null)},function(){return t(true)})}else if(r<3&&a)t(null);return false};var u=function u(t){if(t)r(t);else{i=i.slice(1);o()}};var o=function o(){var t=s(u);if(t)r(null)};o()}var l=function l(t){return t.split(".").reduce(function(t,e){return t.concat(t.length?t[t.length-1]+"."+e:e)},[])};function f(t,e,n,r){var a=false;var i=function i(){return a=true};var s=function s(t){return r(a?u.TRANSITION_CANCELLED:t)};var o=undefined;var f=n?l(n.name):[];var c=l(e.name);var m=Math.min(f.length,c.length);for(o=0;o<m;o+=1){if(f[o]!==c[o])break}var p=f.slice(o).reverse();var v=c.slice(o);var d=n&&o>0?f[o-1]:"";var g=function g(e,n,r){if(a)s();else{var i=p.map(function(e){return t._cmps[e]}).filter(function(t){return t&&t.canDeactivate}).map(function(t){return t.canDeactivate});h(i,e,n,function(t){return r(t?u.CANNOT_DEACTIVATE:null)})}};var y=function y(e,n,r){if(a)s();else{var i=v.map(function(e){return t._canAct[e]}).filter(function(t){return t});h(i,e,n,function(t){return r(t?u.CANNOT_ACTIVATE:null)})}};var w=function w(e,n,r){if(a)s();else{var i=t._cbs["^"+d]||[];h(i,e,n,function(t){return r(t?u.NODE_LISTENER_ERR:null)},true)}};var S=n?[g,y,w]:[y,w];h(S,e,n,s);return i}var t=function(){function t(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(t,r.key,r)}}return function(e,n,r){if(n)t(e.prototype,n);if(r)t(e,r);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var c=function c(t,e,n){return{name:t,params:e,path:n}};var m=function(){function n(t){var r=this;var a=arguments[1]===undefined?{}:arguments[1];e(this,n);this.started=false;this._cbs={};this._cmps={};this._canAct={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=t instanceof o?t:new o("","",t);this.options={useHash:false,hashPrefix:""};Object.keys(a).forEach(function(t){return r.options[t]=a[t]});this._setBase();return this}t(n,[{key:"_setBase",value:function r(){this.base=this.options.base||window.location.pathname.replace(/\/$/,"")}},{key:"setOption",value:function a(t,e){this.options[t]=e;if(t==="base")this._setBase();return this}},{key:"add",value:function i(t){this.rootNode.add(t);return this}},{key:"addNode",value:function s(t,e,n){this.rootNode.addNode(t,e);if(n)this._canAct[t]=n;return this}},{key:"onPopState",value:function h(t){var e=this;var n=t.state||this.matchPath(this.getLocation());if(!n)return;if(this.lastKnownState&&this.areStatesEqual(n,this.lastKnownState))return;this._transition(n,this.lastKnownState,function(t){if(t){var n=e.buildUrl(e.lastKnownState.name,e.lastKnownState.params);window.history.pushState(e.lastKnownState,"",n)}})}},{key:"start",value:function l(t){var e=this;if(this.started){t(u.ROUTER_ALREADY_STARTED);return this}this.started=true;var n=this.options;var r=this.getLocation();var a=this.matchPath(r);var i=function i(n,r){window.addEventListener("popstate",e.onPopState.bind(e));if(t)t(n,r)};var s=function s(){return e.navigate(n.defaultRoute,n.defaultParams,{replace:true},i)};if(a){this.lastStateAttempt=a;this._transition(this.lastStateAttempt,this.lastKnownState,function(t,r){if(!t){window.history.replaceState(e.lastKnownState,"",e.buildUrl(a.name,a.params));i(null,r)}else if(n.defaultRoute)s();else i(t)})}else if(n.defaultRoute){s()}else{i(null)}return this}},{key:"stop",value:function m(){if(!this.started)return this;this.lastKnownState=null;this.lastStateAttempt=null;this.started=false;window.removeEventListener("popstate",this.onPopState.bind(this));return this}},{key:"getState",value:function p(){return this.lastKnownState}},{key:"isActive",value:function v(t){var e=arguments[1]===undefined?{}:arguments[1];var n=arguments[2]===undefined?false:arguments[2];var r=this.getState();if(!r)return false;if(n||r.name===t){return this.areStatesEqual(c(t,e),r)}return this.areStatesDescendants(c(t,e),r)}},{key:"areStatesEqual",value:function d(t,e){return t.name===e.name&&Object.keys(t.params).length===Object.keys(e.params).length&&Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"areStatesDescendants",value:function g(t,e){var n=new RegExp("^"+t.name+"\\.(.*)$");if(!n.test(e.name))return false;return Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"_invokeListeners",value:function y(t,e,n){(this._cbs[t]||[]).forEach(function(t){return t(e,n)})}},{key:"_addListener",value:function w(t,e,n){var r=t.replace(/^(\*|\^|=)/,"");if(r){var a=this.rootNode.getSegmentsByName(r);if(!a)console.warn("No route found for "+r+", listener might never be called!")}if(!this._cbs[t])this._cbs[t]=[];this._cbs[t]=(n?[]:this._cbs[t]).concat(e);return this}},{key:"_removeListener",value:function S(t,e){if(this._cbs[t])this._cbs[t]=this._cbs[t].filter(function(t){return t!==e});return this}},{key:"addListener",value:function _(t){return this._addListener("*",t)}},{key:"removeListener",value:function k(t){return this._removeListener("*",t)}},{key:"addNodeListener",value:function E(t,e){return this._addListener("^"+t,e,true)}},{key:"removeNodeListener",value:function b(t,e){this._cbs["^"+t]=[];return this}},{key:"addRouteListener",value:function P(t,e){return this._addListener("="+t,e)}},{key:"removeRouteListener",value:function A(t,e){return this._removeListener("="+t,e)}},{key:"registerComponent",value:function R(t,e){if(this._cmps[t])console.warn("A component was alread registered for route node "+t+".");this._cmps[t]=e;return this}},{key:"deregisterComponent",value:function N(t){delete this._cmps[t]}},{key:"canActivate",value:function T(t,e){this._canAct[t]=e;return this}},{key:"getLocation",value:function x(){var t=this.options.useHash?window.location.hash.replace(new RegExp("^#"+this.options.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+this.base),"");return t+window.location.search}},{key:"buildUrl",value:function O(t,e){return(this.options.useHash?window.location.pathname+"#"+this.options.hashPrefix:this.base)+this.rootNode.buildPath(t,e)}},{key:"buildPath",value:function L(t,e){return this.rootNode.buildPath(t,e)}},{key:"matchPath",value:function j(t){var e=this.rootNode.matchPath(t);return e?c(e.name,e.params,t):null}},{key:"_transition",value:function C(t,e,n){var r=this;if(this._tr)this._tr();var a=f(this,t,e,function(a){r._tr=null;if(a){if(n)n(a);return}r.lastKnownState=t;r._invokeListeners("="+t.name,t,e);r._invokeListeners("*",t,e);if(n)n(null,t)});this._tr=a;return function(){return!a||a()}}},{key:"navigate",value:function D(t,e,n,r){if(e===undefined)e={};var a=this;if(n===undefined)n={};if(!this.started){r(u.ROUTER_NOT_STARTED);return}var i=this.buildPath(t,e);var s=this.buildUrl(t,e);if(!i)throw new Error('Could not find route "'+t+'"');var o=c(t,e,i);this.lastStateAttempt=o;var h=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(h&&!n.reload){if(r)r(u.SAME_STATES);return}return this._transition(o,this.lastKnownState,function(t,e){if(t){if(r)r(t);return}window.history[n.replace?"replaceState":"pushState"](a.lastStateAttempt,"",s);if(r)r(null,e)})}}]);return n}();m.ERR=u;return{RouteNode:o,Router5:m}});